<%@ page language="java" %>
<%@ page import="java.util.*" %>
<%@ page import="java.net.URL" %>
<%@ page import="java.net.URLClassLoader" %>
<%@ page import="com.sas.oprisk.server.*"%>

<%@ include file="/tiles/taglibs.jsp"%>

<html>
<body>

<%	
final Locale locale = request.getLocale();
final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
final User currentUser = SecurityUtils.getUser(psession);
         
String devMode = System.getProperty("sas.development.mode");
if (!("true".equals(devMode) ||
         currentUser.hasGlobalPermission(GlobalPermission.superuser, psession)))
{
   request.getRequestDispatcher("/InsufficientPermissions.do").forward(request, response);
} 

Properties prop = System.getProperties(); 
%>
<p><b>property java.class.path:</b> <%=prop.getProperty("java.class.path")%>

<p><b>property sun.boot.class.path :</b> <%=prop.getProperty("sun.boot.class.path ")%>

<p><b>attribute org.apache.catalina.jsp_classpath:</b> <%=application.getAttribute("org.apache.catalina.jsp_classpath")%>

<p><b>Using ClassLoader:</b><br />

<%
  //Get the System Classloader
  ClassLoader sysClassLoader = ClassLoader.getSystemClassLoader();
  //Get the URLs
  URL[] urls = ((URLClassLoader)sysClassLoader).getURLs();
  for(int i=0; i < urls.length; i++)
  {
   	out.print(urls[i].getFile());
   	out.print("<br />");
  }  
%>

</body>
</html>