<%@page import="java.util.Arrays"%>
<%@page import="com.sas.solutions.cpb.web.util.LayoutDirection"%>
<%@page import="com.sas.solutions.cpb.services.CPBServiceLocator"%>
<%@page import="java.util.ResourceBundle"%>
<%@page import="com.sas.solutions.cpb.util.DocumentationPropertiesGenerator"%>
<%

String devMode = System.getProperty("sas.development.mode");
if (!("true".equals(devMode)))
{
   request.getRequestDispatcher("/InsufficientPermissions.do").forward(request, response);
} 

String[] fileNames = DocumentationPropertiesGenerator.generateDocProperties();
ResourceBundle cpbBundle = CPBServiceLocator.getCPBRuntimeService().getResourceBundle(request.getLocale());

LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
String dir = "ltr";
if (layoutDirection.isRightToLeft())
{
   dir = "rtl";
}
%>

<html dir="<%=dir%>">
<head>
   <title><%=cpbBundle.getString("cpb.docs.generator.title.txt")%></title>
   
   <style type="text/css">
   <%@ include file="Documentation.css" %>
   </style>
</head>
<body dir="<%=dir%>">
   <% if (fileNames != null) { %>
<pre>
Properties files are generated:
    <%= fileNames[0] %>
    <%= fileNames[1] %>
</pre>
   <% } else { %>
      Error occurred.
   <% } %>
</body>
</html>