<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.assessment.*" %>
<%@ page import="org.apache.struts.util.LabelValueBean" %>
<%    
     Locale locale = request.getLocale();
     final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     
     String exportURL = request.getContextPath() + "/QuestionnaireTemplateCpb.do?method=causes&entryId=causeTypes";
%>

      <mon:include js="/script/checkboxRadioUtil.js" />
      <mon:include js="/components/dialogs/ModalDialog.js"/>
      <mon:include js="/ext/cpbcore/browser/Event.js"/>
      
      <script type="text/javascript">
      
      function selectCauses() {
         var url = "<%= request.getContextPath() %>/CauseTypesChooser2.do" 
            + "?handle=" + encodeURI('${questionnaireTemplateCpbForm.handle}')
            + "&dimensionalArea=" + encodeURI('${questionnaireTemplateCpbForm.dimensionalArea}');
         openModal(url, 'RETChooser');
      }
      
      </script>

            <!-- <input type="hidden" name="type" value="causeType" /> -->
         
           <!-- Assessment Context Path Dimensions -->
         <%
           final Iterator contexts = (Iterator) request.getAttribute("contextsCauses");
           if (contexts != null) {
         %>
           <table width="100%" class="contextBox" cellspacing="0">
              <tr><th><fmt:message key="Questionnaire.includeContext.txt"/></td></tr>
         <%   while (contexts.hasNext()) {
                 final LabelValueBean context = (LabelValueBean)contexts.next();
                 request.setAttribute("contextCause", context);
         %>   <tr>
                 <td>
                 <html:multibox property="selectedCauseContexts" value="<%= context.getValue() %>" onclick="javascript:handleSelectedContextsOnClick('${contextCause.value}', this.checked, 'causeType');"/>
                 <%= context.getLabel() %>
                 </td>
              </tr>
         <%   }
         %></table>
           <%-- special empty value for when no checkboxes are selected --%>
           <input type="hidden" name="selectedCauseContexts" value="<%= QuestionnaireTemplateCpbAction.VALUE_EMPTY %>" />
         <% } %>
         
           <p/>
           
            <mon:tableComponent id="causeType" entryName="causeTypes"
                                wizCursor="refresh" exportXlsUrl="<%= exportURL %>" sortable="false">
         
               <mon:action href="javascript:selectCauses()">
                  <fmt:message key='QuestionnaireTemplateWizard.step.causeTypes.add.txt'/>
               </mon:action>
         
               <c:if test="${causeTypeCount > 0}">
                  <mon:action href="javascript:RiskCauseControlTypes.handleRemoveSelectedOnClick('causeType')">
                     <fmt:message key='QuestionnaireTemplateWizard.step.causeTypes.remove.txt'/>
                  </mon:action>
               </c:if>
         
               <c:set var="checkAllCauses">
                   <input type="checkbox" name="checkAllCauses" id="checkAllCauses" title="<fmt:message key="application.selectAll.tooltip.txt" />"/>
               </c:set>
               <mon:fixedColumn width='20' title="${checkAllCauses}">
                  <input type="checkbox" name="selectedCauseHandles" value="<c:out value='${causeType.handle}'/>" />
               </mon:fixedColumn>
         
               <mon:fixedColumn title='<%= bundle.getString("application.order.tooltip.txt") %>' before="false">         
                  <c:set var="first" value="${causeTypeRowIndex == 0}"/>
                  <c:set var="last" value="${causeTypeRowIndex == causeTypeCount-1}"/>
         
                  <c:if test="${first}">
                     <img border="0" src="<fmt:message key='application.moveup.disabled.image' />" />&nbsp;
                  </c:if>
                  <c:if test="${not first}">
                     <a href="javascript:RiskCauseControlTypes.handleReorderButtonOnClick(<c:out value="${causeTypeRowIndex}" />, 'up', 'causeType')"><img 
                        border="0" src="<fmt:message key='application.moveup.image' />" 
                        alt="<fmt:message key='application.moveup.tooltip.txt'/>" 
                        title="<fmt:message key='application.moveup.tooltip.txt'/>"/></a>&nbsp;
                  </c:if>
                  <c:if test="${last}">
                     <img border="0" src="<fmt:message key='application.movedown.disabled.image' />" />
                  </c:if>
                  <c:if test="${not last}">
                     <a href="javascript:RiskCauseControlTypes.handleReorderButtonOnClick(<c:out value="${causeTypeRowIndex}" />, 'down', 'causeType')"><img 
                        border="0" src="<fmt:message key='application.movedown.image' />" 
                        alt="<fmt:message key='application.movedown.tooltip.txt'/>" 
                        title="<fmt:message key='application.movedown.tooltip.txt'/>"/></a>
                  </c:if>
               </mon:fixedColumn>
         
            </mon:tableComponent>
           
            <script type="text/javascript">
            new CheckboxGroup("questionnaireTemplateCpbForm", "selectedCauseHandles", "checkAllCauses");
            </script>
