<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.assessment.*" %>
<%@ page import="org.apache.struts.util.LabelValueBean" %>
<%    
     Locale locale = request.getLocale();
     final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     
     String exportURL = request.getContextPath() + "/QuestionnaireTemplateCpb.do?method=controls&entryId=controlTypes";
%>

      <mon:include js="/script/checkboxRadioUtil.js" />
      <mon:include js="/components/dialogs/ModalDialog.js"/>
      <mon:include js="/ext/cpbcore/browser/Event.js"/>
      
      <script type="text/javascript">
      
      function selectControls() {
         var url = "<%= request.getContextPath() %>/ControlTypesChooser2.do" 
            + "?handle=" + encodeURI('${questionnaireTemplateCpbForm.handle}')
            + "&dimensionalArea=" + encodeURI('${questionnaireTemplateCpbForm.dimensionalArea}');
         openModal(url, 'RETChooser');
      }
      
      </script>

            <!-- <input type="hidden" name="type" value="controlType" /> -->
              
           <!-- Assessment Context Path Dimensions -->
         <%
           final Iterator contexts = (Iterator) request.getAttribute("contextsControls");
           if (contexts != null) {
         %>
           <table width="100%" class="contextBox" cellspacing="0">
              <tr><th><fmt:message key="Questionnaire.includeContext.txt"/></td></tr>
         <%   while (contexts.hasNext()) {
                 final LabelValueBean context = (LabelValueBean)contexts.next();
                 request.setAttribute("contextControl", context);
         %>   <tr>
                 <td valign="top">
                 <html:multibox property="selectedControlContexts" value="<%= context.getValue() %>" onclick="javascript:handleSelectedContextsOnClick('${contextControl.value}', this.checked, 'controlType');"/>
                 <%= context.getLabel() %>
                 </td>
              </tr>
         <%   }
         %></table>
           <%-- special empty value for when no checkboxes are selected --%>
           <input type="hidden" name="selectedControlContexts" value="<%= QuestionnaireTemplateCpbAction.VALUE_EMPTY %>" />
         <% } %>
           <br/>
         
            <mon:tableComponent id="controlType" entryName="controlTypes"
                                wizCursor="refresh" exportXlsUrl="<%= exportURL %>" sortable="false">
         
               <mon:action href="javascript:selectControls()">
                  <fmt:message key='QuestionnaireTemplateWizard.step.controlTypes.add.txt'/>
               </mon:action>
         
               <c:if test="${controlTypeCount > 0}">
                  <mon:action href="javascript:RiskCauseControlTypes.handleRemoveSelectedOnClick('controlType')">
                     <fmt:message key='QuestionnaireTemplateWizard.step.controlTypes.remove.txt'/>
                  </mon:action>
               </c:if>
         
               <c:set var="checkAllControls">
                   <input type="checkbox" name="checkAllControls" id="checkAllControls" title="<fmt:message key="application.selectAll.tooltip.txt" />"/>
               </c:set>
               <mon:fixedColumn width='20' title="${checkAllControls}">
                  <input type="checkbox" name="selectedControlHandles" value="<c:out value='${controlType.handle}'/>" />
               </mon:fixedColumn>
         
               <mon:fixedColumn title='<%= bundle.getString("application.order.tooltip.txt") %>' before="false">         
                  <c:set var="first" value="${controlTypeRowIndex == 0}"/>
                  <c:set var="last" value="${controlTypeRowIndex == controlTypeCount-1}"/>
         
                  <c:if test="${first}">
                     <img border="0" src="<fmt:message key='application.moveup.disabled.image' />" />&nbsp;
                  </c:if>
                  <c:if test="${not first}">
                     <a href="javascript:RiskCauseControlTypes.handleReorderButtonOnClick(<c:out value="${controlTypeRowIndex}" />, 'up', 'controlType')"><img 
                        border="0" src="<fmt:message key='application.moveup.image' />" 
                        alt="<fmt:message key='application.moveup.tooltip.txt'/>" 
                        title="<fmt:message key='application.moveup.tooltip.txt'/>"/></a>&nbsp;
                  </c:if>
                  <c:if test="${last}">
                     <img border="0" src="<fmt:message key='application.movedown.disabled.image' />" />
                  </c:if>
                  <c:if test="${not last}">
                     <a href="javascript:RiskCauseControlTypes.handleReorderButtonOnClick(<c:out value="${controlTypeRowIndex}" />, 'down', 'controlType')"><img 
                        border="0" src="<fmt:message key='application.movedown.image' />" 
                        alt="<fmt:message key='application.movedown.tooltip.txt'/>" 
                        title="<fmt:message key='application.movedown.tooltip.txt'/>"/></a>
                  </c:if>
               </mon:fixedColumn>
         
            </mon:tableComponent>
            
            <script type="text/javascript">
            new CheckboxGroup("questionnaireTemplateCpbForm", "selectedControlHandles", "checkAllControls");
            </script>
