<%@ include file="/tiles/taglibs.jsp"%>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.framework.server.objects.BusinessObjectList" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.*" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.assessment.*" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.util.UIContextUtil"%>
<%@ page import="com.sas.solutions.cpb.runtime.UIContext" %>
<%@ page import="com.sas.solutions.cpb.web.runtime.ScreenRenderer" %>
<%@ page import="com.sas.fsd.shared.json.*" %>

<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	//final QuestionnaireAssessmentForm form = (QuestionnaireAssessmentForm)
   //   request.getAttribute("questionnaireAssessmentForm");

	//QuestionnaireAssessmentModel model = QuestionnaireAssessmentAction.getModel(request);  //
   QuestionnaireAssessmentModel model = QuestionnaireAssessmentModel.getInstance(request);
   String templateName = (model != null && model.getForm() != null) ? model.getForm().getTemplate() : "";
   
   UIContext uiContext = UIContextUtil.getUIContext(request);
   
   String uiContextId = (uiContext != null) ? uiContext.getUIContextId() : "";
%>

      <mon:include js="/script/checkboxRadioUtil.js" />
   
      <script type="text/javascript">
      function viewAssessors(roleHandle, areaHandle) {
            openModal("QuestionnaireAssessment.do?method=viewAssessors" +
                     "&roleHandle=" + encodeURI(roleHandle) +
                     "&areaHandle=" + encodeURI(areaHandle) + 
                     "&popup=true");
         }
      
      var POSITION_CONTAINER_MAP = <% if (model != null) model.encodePositionContainerMap(out); %>;
      
      QuestionnaireAssessment = {};
      
      QuestionnaireAssessment.handleSaveInstances = function()
      {
         var url = "<%= request.getContextPath() %>/QuestionnaireAssessment.do?method=saveInstances";
         if (document.forms[0]) {
            document.forms[0].action = url;
            document.forms[0].submit();
         }
      }
      
      QuestionnaireAssessment.selectInstances = function(positionContainerHandle, type)
      {
         var positionContainer = POSITION_CONTAINER_MAP[positionContainerHandle];
      
         var url =
            'QuestionnaireAssessmentInstancesChooser.do' +
            '?positionContainer=' + encodeURI(positionContainerHandle) +
            '&type=' + type +
            '&questionnaireTemplate=' + encodeURI('<%= templateName %>') +
            '&onsave=QuestionnaireAssessment.handleSaveInstances()' +
            '&form=questionnaireAsmtForm' +
            '&property=handleList' + 
            '&<%= ScreenRenderer.PARAM_UI_CONTEXT_ID %>=<%= uiContextId %>';
         
         var instanceList = positionContainer[type];
         
         for (var i = 0; i < instanceList.length; i++)
         {
            url += "&selectedHandle=" + instanceList[i];
         }
         
         <% if ( model != null && (model.isFilterCauses() || model.isFilterControls())) { %>
         if (type != 'RISKS'){
            var selectedRisks = positionContainer['RISKS'];
            
            if (selectedRisks.length > 0){
               for (var j = 0; j < selectedRisks.length; j++ ){
                  url += "&sr=" + selectedRisks[j];
               }
            }
         }
         <% } %>
      
         openModal(url, 'instancesChooser', doFeatures('width=640,height=570,scrollbars,resizable,status'));
      }
      </script>

         <mon:table width="100%" class="displayTable" cellspacing="0" name="requestScope.positionContainerList" id="entry">
      <%
            PositionContainer positionContainer = (PositionContainer) pageContext.findAttribute("entry");
      %>
            <mon:title><span class='requiredIndicator'>*</span><fmt:message key="AssessmentWizard.step.positions.txt" /></mon:title>
            
            <display:setProperty name="basic.msg.empty_list" value='<%= bundle.getString("displayTable.empty.fmt.txt") %>' />
            
            <c:set var="checkAll">
                <input type="checkbox" name="selectAll" id="selectAll" title="<fmt:message key="application.selectAll.tooltip.txt" />"/>
            </c:set>
      
            <display:column title='${checkAll}'>
               <html:multibox property="positions" value="<%= positionContainer.getHandle() %>"></html:multibox>
            </display:column>
            
            <display:column title='<%= bundle.getString("AssessmentWizard.positions.role.txt") %>' >
               <c:out value="<%= positionContainer.getRoleCaption() %>" />
            </display:column>
         
            <display:column title='<%= bundle.getString("AssessmentWizard.positions.scope.txt") %>' >
               <c:out value="<%= positionContainer.getAreaCaption() %>" />
            </display:column>
            
            <display:column title='<%= bundle.getString("AssessmentWizard.positions.selectedRisks.txt") %>' >
      <%
            if (positionContainer.getTotalRiskInstanceCount() > 0)
            {
      %>
               <a href="javascript:QuestionnaireAssessment.selectInstances('<%= positionContainer.getHandle() %>', '<%= AssessmentWizardModel.AssessmentWizardInstanceType.RISKS %>');">
               <%= positionContainer.getRiskInstancesSelectionCaption(request) %>
               </a>
      <%
            }
            else
            {
      %>
            <%= positionContainer.getRiskInstancesSelectionCaption(request) %>
      <%
            }
      %>
            </display:column>
            
            <display:column title='<%= bundle.getString("AssessmentWizard.positions.selectedCauses.txt") %>' >
      <%
            if (positionContainer.getTotalCauseInstanceCount() > 0)
            {
      %>
               <a href="javascript:QuestionnaireAssessment.selectInstances('<%= positionContainer.getHandle() %>', '<%= AssessmentWizardModel.AssessmentWizardInstanceType.CAUSES %>');">
               <%= positionContainer.getCauseInstancesSelectionCaption(request) %>
               </a>
      <%
            }
            else
            {
      %>
            <%= positionContainer.getCauseInstancesSelectionCaption(request) %>
      <%
            }
      %>
            </display:column>
            
            <display:column title='<%= bundle.getString("AssessmentWizard.positions.selectedControls.txt") %>' >
      <%
            if (positionContainer.getTotalControlInstanceCount() > 0)
            {
      %>
               <a href="javascript:QuestionnaireAssessment.selectInstances('<%= positionContainer.getHandle() %>', '<%= AssessmentWizardModel.AssessmentWizardInstanceType.CONTROLS %>');">
               <%= positionContainer.getControlInstancesSelectionCaption(request) %>
               </a>
      <%
            }
            else
            {
      %>
            <%= positionContainer.getControlInstancesSelectionCaption(request) %>
      <%
            }
      %>
            </display:column>
            
            <display:column title='<%= bundle.getString("AssessmentWizard.scoping.section.assessors.txt") %>' >
               <a href="#" onclick="viewAssessors('<c:out value="<%= positionContainer.getRole().getHandleString() %>" />', '<c:out value="<%= positionContainer.getArea().getHandleString() %>" />')"><img 
                  src="<%= request.getContextPath() %>/<fmt:message key="Assessments.viewAssessors.image" />"
                  border="0"/>
               </a>
            </display:column>
      
         </mon:table>
         
         <script type="text/javascript">
         new CheckboxGroup("questionnaireAsmtForm", "positions", "selectAll");
         </script>
