<%@page import="com.sas.solutions.cpb.web.util.CPBUtil"%>
<%@page import="org.apache.commons.lang.StringUtils"%>
<%@page import="com.sas.oprisk.server.cpb.uiDefType.RiskInstanceUIDefinitionType"%>
<%@page import="java.util.Map"%>
<%@page import="com.sas.solutions.cpb.screendefs.Field"%>
<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.oprisk.monitor.web.cpb.util.UIContextUtil"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@ include file="/tiles/taglibs.jsp" %>

<%@page import="com.sas.oprisk.monitor.web.csa.riskInstance.CauseInstanceTableQueryAction"%><mon:include js="/script/checkboxRadioUtil.js" />

<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final UIContext uiContext = UIContextUtil.getUIContext(request);
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);   
   final Field field = componentInfo.getField();
   
   final Map params = field.getParameters(uiContext);
   final String riskTypeFieldNm = (String)params.get(RiskInstanceUIDefinitionType.PARAM_RISK_TYPE_FIELD);
%>

<script type="text/javascript">
function refreshKnownCauses(name) {
   
   var params = getParamsForTable(document.forms[0], 
      "<c:out value='${componentInfo.component.tableEntryId}' />", 
      "<c:out value='${componentInfo.field.name}' />");
   
   RCSAService.refreshKnownCauses(
         "<c:out value='${componentInfo.field.name}' />", 
        params,
      function(pageMod) {
        PageModification.handle(pageMod);
      }
   );
}
function addCauseInstance(handle) {
   var path = "/CauseInstance.do"
      + "?method=create"
      + "&riHandle=" + encodeURI(document.forms[0].riHandle.value)
      + "&location=" + encodeURI(getInstanceArea())
      + "&qnrHandle=" + encodeURI("<c:out value='${riskInstanceCPBForm.qnrHandle}'/>");
   //path = escape(path);
   doRiskInstance("forward&path=" + path + "&returnMethod=handleNewCause");
}

function editCauseInstance(handle) {
   
   var path = "/CauseInstance.do"
      + "?method=select"
      + "&riHandle=" + encodeURI(document.forms[0].riHandle.value)
      + "&ciHandle=" + handle // handle already encoded
      + "&qnrHandle=" + encodeURI("<c:out value='${riskInstanceCPBForm.qnrHandle}'/>") 
      <c:if test="${model.readOnly}">+ "&readOnly=true"</c:if>
      <c:if test="${not empty uiContext.pointInTime}">+ "&pointInTime=<c:out value="${uiContext.pointInTime}"/>"</c:if>;
   //path = escape(path);
   doRiskInstance("forward&path=" + path + "&returnMethod=refreshKnownCauses");
}

function selectCauseInstance() {
   openModal(
      "<%= request.getContextPath() %>" 
      + "/KnownCauseInstanceChooserQuery.do"
      + "?riHandle=" + encodeURI(document.forms[0].riHandle.value)
<% if (StringUtils.isEmpty(riskTypeFieldNm)) { %>
      + "&areaHandle=" + encodeURI(getInstanceArea())
<% } else { %>
      + "&retHandle=" + encodeURI(document.forms[0].<%= CPBUtil.getSafeFieldName(riskTypeFieldNm) %>.value)
<% } %>
      + "&constrainByMappings=true",
      "causeInstancePopup", 
      "width=680,height=480,scrollbars,resizable,status");
}

function removeSelectedCauseMappings() {
   if (!hasAnySelectedCheckboxes(document.forms[0], "selectedKnownCauses")) {
      alert("<fmt:message key='DimensionRelations.mustSelectOne.txt'/>");
      return;
   }

   if (confirm("<fmt:message key='DimensionRelations.removeSelected.confirm.txt'/>")) {
      var f = document.forms[0];
      f.action = f.action + "?method=deleteCauses";
      f.action = f.action + "#causesTable";  
      f.submit();
   }
}
</script>
<div id="causeInstances_div">
     <jsp:include page = "CauseInstanceTableContent.jsp" />
</div>

<!--  override submit for supporting ajax sorting  -->
<script type="text/javascript">
   var tableComp = getTableComponent("<c:out value='${componentInfo.component.tableEntryId}' />", "<c:out value='${componentInfo.field.name}' />");
   tableComp.submit = refreshKnownCauses;
</script>