<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.framework.server.util.*" %>
<%@ page import="com.sas.oprisk.monitor.util.RequestDebug" %>
<%@ page import="com.sas.solutions.cpb.runtime.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.*" %>
<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);   
   final String context = request.getContextPath();
   final boolean readOnly = Boolean.FALSE.equals(request.getAttribute("canEdit"));
   final UIContext uiContext = RequestUtil.getUIContext(request);
   
%>
<mon:include js="/script/checkboxRadioUtil.js" />

<script type="text/javascript">

function addTestDefinitions()
{
   var url = 
      "<%= context %>/TestDefinitionChooserQuery.do" 
         + "?testDefinitionGroupHandle=" + encodeURI(document.forms[0].handle.value)
         + "&TCArea=" + encodeURI(document.forms[0].LOCATION.value);
   openModal(
	url,
	"TestDefinitionsPopup", 
	"width=680,height=480,scrollbars,resizable,status");
}

// callback from "Add Test Definitions" window.
function addSelectedTestDefinitions( selectionArray ) 
{
   document.forms.testDefinitionGroupCPBForm.tdsToAddOrRemove.value = selectionArray;
   invokeMethod('addTestDefinitions');
}
function editTestDefinition(handle) {
	   
	   var path = "/TestDefinitionEdit.do"
	      + "?method=select"
	      + "&handle=" + encodeURI(handle)
	      <c:if test="${model.readOnly}">+ "&readOnly=true"</c:if>
	      <c:if test="${not empty uiContext.pointInTime}">+ "&pointInTime=<c:out value="${uiContext.pointInTime}"/>"</c:if>;
	   path = escape(path);
	   invokeMethod("forward&path=" + path + "&returnMethod=refresh");
	}
function removeSelectedTestDefinitions() 
{
   var values = getSelectedCheckboxValues(document.forms[0], "tdHandle");
   if (values == null || values.length == 0) {
      var mustSelectOne = unescape("<%= ParsingUtils.escape(bundle.getString("testDefinitionGroupEditor.removeTestDefinitions.mustSelectOne.message.txt")) %>");
      mustSelectOne = formatMessage(mustSelectOne);
      alert( mustSelectOne );
   } else {
      var msg = unescape("<%= ParsingUtils.escape(bundle.getString("testDefinitionGroupEditor.removeTestDefinitions.confirm.message.txt")) %>");
      msg = formatMessage(msg);
      if (confirm(msg)) {
         document.forms.testDefinitionGroupCPBForm.tdsToAddOrRemove.value = values;
         invokeMethod( 'removeTestDefinitions' );
      }
   }
}

function invokeMethod( methodName ) {
  document.forms.testDefinitionGroupCPBForm.action = 
    "<%= context %>/TestDefinitionGroupEditor.do?method=" + methodName;
  document.forms.testDefinitionGroupCPBForm.submit();
}

</script>

<input type="hidden" name="tdsToAddOrRemove" />

<jsp:include page="TestDefinitionGroupContentsTableContent.jsp" flush="true"/>
