<%@page import="com.sas.oprisk.monitor.web.controlTesting.testDefinitions.LinkedControlTableComponent"%>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.controlProfile.ControlProfileEntry" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.tests.*" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.controlProfile.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.*" %>

<%@ include file="/tiles/taglibs.jsp" %>


<%@page import="com.sas.fsd.shared.json.JSONEncoder"%><%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   
   final Boolean readOnlyBoolean = (Boolean)request.getAttribute("readOnly");
   final boolean readOnly = (readOnlyBoolean != null)? readOnlyBoolean.booleanValue() : true ;

   //preview screen in ScreenDefinitions gets NPE if this check is not there.
   final Boolean freshBoolean = (Boolean)request.getAttribute("fresh");
   final boolean fresh;
   if(freshBoolean != null){
       fresh = freshBoolean.booleanValue();
   }
   
   final Boolean isValidatedBoolean = (Boolean) request.getAttribute("isValidated");
   final boolean isValidated = (isValidatedBoolean != null) ? isValidatedBoolean.booleanValue() : false;
   
   HashMap committedControlInstances = (HashMap) request.getAttribute("committedControlInstances");
   if (committedControlInstances == null) committedControlInstances = new HashMap();
   
   String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
      + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
         
   final TestDefinitionModel model = (TestDefinitionModel)request.getAttribute(TestDefinitionModel.ATTR_MODEL);
   final String taggedPointerHandle = model != null ? model.getTestDefinition().getTaggedPointerHandle().toString() : "";
   final String exportUrl = request.getContextPath() + "/TestDefinitionEdit.do?method=export&entryId=controls&testDefnHandle=" + 
            taggedPointerHandle;
     
   MonitorContext mc = MonitorContext.getMonitorContext(request);
   java.util.Map formatters = new java.util.HashMap();
   formatters.put("lastTestConclusions", new TestConclusionCellFormatter(mc));
   formatters.put("lastTestMeasures",   new TestMeasureCellFormatter(mc));
   formatters.put("lastCertification", new CertificationCellFormatter(mc));
   final String fieldName = "linkedControl";
   boolean valid = !RequestUtil.isFieldValueInvalid(fieldName, pageContext);
   String statusFilter=(String)request.getAttribute(LinkedControlTableComponent.PARAM_STATUS_FILTER);
   
   String globalTesterOption = (String)request.getAttribute(LinkedControlTableComponent.PARAM_GLOBAL_TESTER);
%>

<mon:include js="/script/checkboxRadioUtil.js" />
   
<script type="text/javascript">
   //shows the control instance in a new popup window as readonly. The new window closes once "Done" viewing.
   function showControlInstance(handle) {    
       openModal(
         "<%= request.getContextPath() %>" 
         + "/ControlInstance.do?method=select&handle="
         + handle + "&readOnly=true&popup=true",
         "controlInstancePopup", 
         "width=650,height=450,scrollbars,resizable,status");
   }
   
   //method to show a pop-up window that will show the controls that can be selected based on a ORA.
   function addControls() {
       openModal(
            "<%= request.getContextPath() %>" 
            + "/ControlInstancesQuery.do?tdHandle="
            + document.forms[0].handle.value
            <%if(statusFilter!=null){%>
            + "&statusFilter=<%=statusFilter%>"
            <%}%>            
            + "&TCArea=" + document.forms[0].LOCATION.value,
            "controlInstancesPopup", 
            "width=680,height=480,scrollbars,resizable,status");
   }
   
   
   
   //method to add the selected controls from "Add Controls" window and refresh the current Test Definition screen.
   //Invoked on clicking the "Add" or "Add and Close" buttons.
   function addSelectedControls(selectionArray) {
      // store selection array in hidden field
      document.forms.testDefinitionCPBForm.controlsToAddOrRemove.value = selectionArray;
      
      // submit form and add selected controlds
      doTestDef("modifyControls", "add");
   }
   
   
   
   function addControlsByRisk() {     
   var tdORA = document.forms[0].LOCATION.value;   
   if(tdORA==null||tdORA==''){
      alert("<fmt:message key='testDefinition.controlsByRisk.error.noORA.txt'/>");
      return;
   }
      openModal(
            "<%= request.getContextPath() %>" 
            + "/ControlInstancesByRiskQuery.do?tdHandle="
            + "&risks_TCArea=" + encodeURI(tdORA)
            + encodeURI(document.forms[0].handle.value) 
            <%if(statusFilter!=null){%>
            + "&statusFilter=<%=statusFilter%>"
            <%}%>            
            + "&tdAreaHandle=" + encodeURI(tdORA),
            "controlInstancesByRiskPopup");     
   }

   function manageTesters( ciHandle, readOnly ) {
      var f = document.forms.testDefinitionCPBForm;
      var extraParams = 'method=manageTesters&ciHandle=' + ciHandle;
      if(readOnly){
          extraParams += "&readOnly=true"
      }
      f.action = '<%= request.getContextPath() %>/TestDefinitionEdit.do?'  + extraParams;
      f.submit();
   }
   
   function createTest( ciHandle ) {
      var f = document.forms.testDefinitionCPBForm;
      var extraParams = 'method=createTest&ciHandle=' + ciHandle;
      f.action = '<%= request.getContextPath() %>/TestDefinitionEdit.do?'  + extraParams;
      f.submit();
   }
   
   function removeControl( ciHandle, name) {
      var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
         "TestDefinition.removeControl.confirm.message.fmt.txt")) %>");
      msg = formatMessage(msg, unescape(name));
      if (confirm(msg)) {                 
            document.forms.testDefinitionCPBForm.controlsToAddOrRemove.value = ciHandle;
            doTestDef("removeControl", "remove");
         } 
   }
   
   function applyTester(){
      doTestDef("applyTester", '<%= globalTesterOption %>');
   }

</script>

    <input type="hidden" name="controlsToAddOrRemove" />
    <mon:tableComponent entryName="controls" 
      required="true" valid="<%= valid %>"
      id="control" wizCursor="refresh" exportXlsUrl="<%= exportUrl %>" columnFormatters="<%= formatters %>" >
    <%
      final ControlProfileEntry entry = (ControlProfileEntry)pageContext.findAttribute("control");
      String controlName = "";
      boolean userCanCreateTest = false;
      boolean controlIsCommitted = false;
      if(entry != null) {
         controlName = ParsingUtils.escape(entry.getControlInstNm());
         
         userCanCreateTest = TestPlan.object.can(Do.CREATE, entry.getLocation(psession), psession);
         controlIsCommitted = committedControlInstances.containsKey(entry.getControlInstRk());
      }

      boolean canCreateTest = isValidated && controlIsCommitted && userCanCreateTest;
      
    %>
       <!-- This title tag is not actually used. The title is specified in Custom Page XML label tag -->
       <mon:title><fmt:message key="testDefinition.section.controls.txt"/></mon:title>
       <% if (!readOnly) { /*manage testers*/%>
         <mon:action href='javascript:addControls()'><fmt:message key='testDefinition.title.controls.add.txt'/></mon:action>&nbsp;|&nbsp;                
         <mon:action href='javascript:addControlsByRisk()'><fmt:message key='testDefinition.title.controls.addByRisk.txt'/></mon:action>&nbsp;|&nbsp;    
         <mon:fixedColumn before="false" title='<%= bundle.getString("manageTesters.menu.txt") %>' >
         <a href="javascript:manageTesters('<c:out value='${control.handleString}'/>')">
            <img border="0" src="<fmt:message key='application.selectuser.image' />"  
                 alt="<fmt:message key='manageTesters.menu.txt'/>" 
                 title="<fmt:message key='manageTesters.menu.txt'/>"/>
         </a>
      </mon:fixedColumn>      
       <% } %>

   
  <% if (readOnly) { /*view testers*/%>
         <mon:fixedColumn before="false" title='<%= bundle.getString("manageTesters.readOnly.menu.txt") %>' >
         <a href="javascript:manageTesters(encodeURI('<c:out value='${control.handleString}'/>'), '<%= readOnly %>')">
         <img border="0" src="<fmt:message key='application.selectuser.image' />"  
                 alt="<fmt:message key='manageTesters.readOnly.menu.txt'/>" 
                 title="<fmt:message key='manageTesters.readOnly.menu.txt'/>"/>
            
         </a>
      </mon:fixedColumn>

      <%
  }
      if (readOnly && isValidated) { /*create test column*/ %>
      <mon:fixedColumn before="false" title='<%= bundle.getString("testDefinition.createTest.menu.txt") %>' >
      <%
      if (canCreateTest) {%>
         <a href="javascript:createTest(encodeURI('<c:out value='${control.handleString}'/>'))">
            <img border="0" src="<%=ThemedImage.NEW_ELEMENT.getURL(request)%>"  
                 alt="<fmt:message key='application.createNewFrom.tooltip.txt'/>" 
                 title="<fmt:message key='application.createNewFrom.tooltip.txt'/>"/>
         </a>
         <%} else { %>
            &nbsp;
         <%}%>
      </mon:fixedColumn>
      <% } 
      if (!readOnly) {
      %>
      <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.remove.txt") %>' >
         <a href="javascript:removeControl('<c:out value='${control.handleString}'/>', '<%= ParsingUtils.escape(controlName) %>')">
            <img border="0" src="<fmt:message key='application.remove.image' />"  
                 alt="<fmt:message key='application.remove.tooltip.txt'/>" 
                 title="<fmt:message key='application.remove.tooltip.txt'/>"/>
         </a>
      </mon:fixedColumn>
    <%  }  
   TestDefinition td = (TestDefinition) request.getAttribute("testDefinition");
   boolean bOpen = false;
   if(entry != null && td != null)
      bOpen = td.getTesterPool(ControlInstanceHandle.create(entry.getHandleString()), psession).isModeOpen();
   %>   
   <mon:fixedColumn width='1%' title='<%= bundle.getString("controlTesting.testersAssigned.title.txt") %>' before="false" valign="top" >                 
      <%if(td!= null && !bOpen) { %>          
         <fmt:message key='yesno.yes.txt' />  
      <% } else { %>
         <fmt:message key='yesno.no.txt' />
      <% } %>
   </mon:fixedColumn> 

    </mon:tableComponent>
<c:if test="${uiContext.hasInvisibleLinkedControls}">
   <mon:InfoMessage>
      <fmt:message key="testDefinition.linkedControls.hasInvisibleItems.txt" />
   </mon:InfoMessage>
</c:if>  

<%
   if (globalTesterOption != null && !readOnly){
%>
<table>
<tr id="testDefinition_globalTester">   
   <th class="fieldlabel" >
       <mon:label property="globalTester" separatorVisible="true"
          key="testDefinition.field.globalTester.displayName.txt" />
   </th>
   <td class="field">
       <mon:UserChooser property="globalTester"
         locationProperty="LOCATION"
         secureObjectClass="<%= TestResult.class.getName() %>"
         secureAction="<%= Do.UPDATE.getValue() %>" 
       />
   </td>
   <td>
       <button class="button" onmouseout="this.className='button'" onmouseover="this.className='button buttonRollover'" onclick="applyTester()" style="float: left; margin-right: 5px;" type="button">Apply</button>
   </td>
</tr>
</table>
<%
   }
%>