<%@ include file="/tiles/taglibs.jsp"%>

<%@page
   import="com.sas.oprisk.monitor.web.admin.lockedObjects.LockedObjectQueryForm"%>
<%@page import="java.util.*"%>

<%@page
   import="com.sas.oprisk.monitor.web.admin.lockedObjects.LockedObjectEntry"%>
<%@page import="com.sas.oprisk.framework.server.util.ParsingUtils"%><%
   final Locale locale = request.getLocale();
			final ResourceBundle bundle = ApplicationProperties
					.getBundle(locale);

			LockedObjectQueryForm form = (LockedObjectQueryForm) request
					.getAttribute("lockedObjectQueryForm");
			String objectType = form.getObjType();
			String exportUrl = request.getContextPath()
					+ "/LockedObjectQuery.do"
					+ "?entryId=lockedObjects&objectType=" + objectType
					+ "&location=" + form.getLocation();
			String feature = (String) request.getAttribute("feature");

			String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\""
					+ bundle.getString("application.selectAll.tooltip.txt")
					+ "\" />";
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/script/checkboxRadioUtil.js" />

      <script type="text/javascript">
      
      function areaSelected() {
         submitForm()
         return false;
      }
      
      function submitForm() {
         var f = document.forms.lockedObjectQueryForm;
         if (f.lockedObjects_TCStart) {
            f.lockedObjects_TCStart.value = '0';
         }   
         f.submit();
      }
      
      function viewObject(objHandle) {
         objHandle = decodeURI(objHandle);
         var f = document.forms.lockedObjectQueryForm;
         var sIndex = objHandle.indexOf("<%=TaggedPointerHandle.HANDLE_SEPARATOR%>");
         var objectType = objHandle.substring(0, sIndex);
         var handle = objHandle.substring(sIndex + 1);
         var extraParams = '?method=viewObject' + '&objectType=' + objectType
               + '&objectHandle=' + encodeURI(handle);
         f.action = "<%=request.getContextPath()%>/LockedObject.do" + extraParams;
         f.submit();
      }
      
      function unlockSelected() {
         var f = document.forms.lockedObjectQueryForm;
      
         var chkCount = getSelectedCheckboxCount(f, "handle");
      
         if (chkCount == 0) {
            alert(unescape("<%=ParsingUtils.escape(bundle
							.getString("application.mustSelectOne.txt"))%>"));      
         } else {
            var msg = unescape("<%=ParsingUtils.escape(bundle
							.getString("lockedObjects.confirmUnlock.fmt.txt"))%>");
            msg = formatMessage(msg, chkCount);
            if (confirm(msg)) {
               f.action = "<%=request.getContextPath()%>/LockedObject.do?method=unlock";
               f.submit();
            }
         }
      }
      
      </script>
   </mon:Head>
   <mon:Body>
      <html:form action="/LockedObjectQuery">
         <mon:Content>
            <table>
               <tr>
                  <th class="fieldlabel"><fmt:message
                     key='application.objectType.txt' />:</th>
                  <td class="field"><mon:select property="objType">
                     <html:options name="request"
                        collection="objectTypes" property="value"
                        labelProperty="label" />
                  </mon:select> &nbsp; <input type="button" class="button"
                     onmouseover="this.className='button buttonRollover'"
                     onmouseout="this.className='button'"
                     value="&nbsp;<fmt:message key='goButton.txt' />&nbsp;"
                     onclick="submitForm()" /></td>
               </tr>
            </table>

            <br />

            <c:if test="${not empty lockedObjectQueryForm.objType}">

               <mon:DimAreaChooser property="location"
                  feature="<%=feature%>" forFiltering="true"
                  selectMethod="areaSelected" />

               <br />

               <mon:tableComponent
                  entryName="lockedObjects" id="lockedObject"
                  exportXlsUrl="<%=exportUrl%>">
                  <mon:action href="javascript:unlockSelected()">
                     <fmt:message key='lockedObject.button.unlock.txt' />
                  </mon:action>

                  <mon:fixedColumn width="10" title="<%= selColTitle %>">
                     <%
                        LockedObjectEntry lockedObject = (LockedObjectEntry) pageContext
                     												.findAttribute("lockedObject");
                     										String handleStr = lockedObject
                     												.getLockHandle();
                     										boolean selected = form
                     												.isHandleSelected(handleStr);
                     %>
                     <input type="checkbox" name="handle"
                        value="<c:out value="<%= handleStr %>" />"
                        <%=selected
												? "checked='true'"
												: ""%> />
                  </mon:fixedColumn>
               </mon:tableComponent>
               <script type="text/javascript">
                  new CheckboxGroup("lockedObjectQueryForm", "handle", "selectAll");
               </script>

            </c:if>
         </mon:Content>
      </html:form>
   </mon:Body>
</mon:Page>