<%@ page import="com.sas.oprisk.server.iap.Commentable" %>
<%@ page import="com.sas.oprisk.monitor.web.MonitorContext" %>
<%@ page import="com.sas.oprisk.framework.server.persistence.PersistenceSession" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.CommentsTableTag"%>
<%@ page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@ page import="com.sas.oprisk.server.cpb.MonitorUIDefinitionType"%>
<%@ page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@ page import="com.sas.solutions.cpb.web.util.RequestUtil"%>
<%@ page import="com.sas.oprisk.monitor.web.layout.*" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   PageLayout pageLayout = PageLayout.getPageLayout(request);
	java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
	final Commentable commentsContainer = (Commentable)request.getAttribute(CommentsTableTag.ATTR_COMMENTS_CONTAINER);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final MonitorContext mc = MonitorContext.getMonitorContext(request);
   
   Boolean readOnlyComments = (Boolean)request.getAttribute(CommentsTableTag.ATTR_READ_ONLY);
   Boolean immediateSave = (Boolean)request.getAttribute(CommentsTableTag.ATTR_IMMEDIATE_SAVE);

   String fieldName = "comments";
   String uiContextId = "";
   
   // if this is being used in a CPB screen, we can get some extra info
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);
   if (componentInfo != null && MonitorUIDefinitionType.COMP_COMMENTS.equals(componentInfo.getComponent().getName())) {
      fieldName = componentInfo.getField().getName();
      final UIContext uiContext = RequestUtil.getUIContext(request);
      uiContextId = uiContext.getUIContextId();
   }   

%>

<mon:include js="/dwr/engine.js" />
<mon:include js="/dwr/util.js" />
<mon:include js="/dwr/interface/CommonService.js" />

<mon:include js="/ext/cpbcore/cpb.js" />

<c:if test="${not commentsScriptWritten}">
	<c:set var="commentsScriptWritten" value="true" scope="request" />

<script type="text/javascript">
<%-- Create a new Comment --%>
function addComment() {

   popupAnchor = "#comments" + "<c:out value='${commentsContainer.taggedPointerHandle}' />";
   openModal(
      "<%= request.getContextPath() %>" 
      + "/Comment.do?method=add"
      + "&immediateSave=" + <%= immediateSave %>
      + "&attachedTo=" + encodeURI("<c:out value='${commentsContainer.taggedPointerHandle}' />")
      + "&cpb_uiContextID=<%= uiContextId %>",
      "commentPopup", "width=640,height=570,scrollbars,resizable");
}

<%-- View Comment (not currently used) --%>
function viewComment(tpHandle,  commentHandle) {
   window.open("<%= request.getContextPath() %>" 
      + "/Comment.do?method=view"
      + "&commentHandle=" + commentHandle
      + "&attachedTo=" + "<c:out value='${commentsContainer.taggedPointerHandle}' />",
      "commentPopup", doFeatures("width=750,height=500,scrollbars,resizable"));
}


<%-- Remove Comment (not currently used) --%>
function removeComment(tpHandle,  commentHandle) {
   popupAnchor = "#comments" + tpHandle;
   openModal(
      "<%= request.getContextPath() %>" 
      + "/Comment.do?method=deleteOk" 
      + "&commentHandle=" + commentHandle
      + "&immediateSave=" + <%= immediateSave %>
      + "&attachedTo=" + "<c:out value='${commentsContainer.taggedPointerHandle}' />",
      "commentPopup", "width=640,height=570,scrollbars,resizable");
}

<%-- Refresh Comments Table --%>
function refreshComments(tpHandle, showSaveMessage) {
   var params = cpb.getCPBParams(document.forms[0]);
   
   if (showSaveMessage && window.displayMessages)
   {
      var messages = [{text: "<%= pageLayout.getString("application.saved.txt") %>"}];
      
      // show message on parent window after the refresh...
      window.displayMessages(cpb.INFO_MESSAGES_TYPE, messages);
   }
   
   CommonService.refreshComments(
      tpHandle,
      "<%= fieldName %>",
      <%= readOnlyComments %>,
      <%= immediateSave %>,
      params,
      function(html) {
         closeModal("commentPopup");
         elementById("comments" + tpHandle).innerHTML = html;
      }
   );
}

</script>

</c:if>

<div id="comments<c:out value='${commentsContainer.taggedPointerHandle}' />">
<jsp:include page = "CommentsContent.jsp" />
</div>
