LinkedBusinessObjectsChooser = {};

LinkedBusinessObjectsChooser.getForm = function()
{
   return document.getElementById("queryForm");
}

LinkedBusinessObjectsChooser.areAnySelected = function(form)
{
   var checkboxList = form.elements["targetBusinessObjectRkList"];
   if (!checkboxList)
   {
      return false;
   }
   
   if (checkboxList.nodeName)
   {
      checkboxList = [checkboxList];
   }
   
   for (var i = 0; i < checkboxList.length; i++)
   {
      var checkbox = checkboxList[i];
      
      if (checkbox.checked && !checkbox.disabled)
      {
         return true;
      }
   }
   
   return false;
}

LinkedBusinessObjectsChooser.add = function()
{
   var form = LinkedBusinessObjectsChooser.getForm();
   
   if (!LinkedBusinessObjectsChooser.areAnySelected(form))
   {
      alert(AppProperties["AssessmentWizard.error.noSelections.txt"]);
      return;
   }
   
   FormUtil.submitForm(form, {
      method: 'add'
      });
}

LinkedBusinessObjectsChooser.addAndClose = function()
{
   var form = LinkedBusinessObjectsChooser.getForm();
   
   if (!LinkedBusinessObjectsChooser.areAnySelected(form))
   {
      alert(AppProperties["AssessmentWizard.error.noSelections.txt"]);
      return;
   }
   
   var submitMethod = 'addAndClose';
   if (!window.opener){
      submitMethod = 'addAndPop';
   }
   
   FormUtil.submitForm(form, {
      method: submitMethod
      });
}

LinkedBusinessObjectsChooser.close = function()
{
   if (!window.opener){
      var form = LinkedBusinessObjectsChooser.getForm();
      FormUtil.submitForm(form, {
         method: 'closeAndPop'   // 
      });
   }
   else {
      window.opener.closeModal();
   }
}