<%@ page import="com.sas.oprisk.monitor.web.tags.ora.*" %>
<%@ page import="com.sas.oprisk.server.logical.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.*" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   final OraChooserTag.OraChooserModel ocm = (OraChooserTag.OraChooserModel)request.getAttribute("ocmodel");
%>

<div class="section">

<table class="sectionheader" width="100%" cellspacing="0" cellpadding="0">
   <tr>
      <td class="sectionheadertext">
		<c:if test="${ocmodel.collapsible}">		
		&nbsp;<a href="#" id="<c:out value='${ocmodel.id}' />_toggle_href" ><img id="<c:out value='${ocmodel.id}' />_toggle_img" src="<fmt:message key='application.minus.image'/>" border="0" width="9" height="9" /></a>
		</c:if>&nbsp;<%
      
         CPBUtil.writeSectionIndicators(
            ocm.getId(), ocm.isRequired() && !ocm.isReadOnly(), 
            !ocm.isValid(), request.getLocale(), pageContext);
      
%><c:out value="${ocmodel.title}" />
      <span id="<c:out value='${ocmodel.id}' />_title"><c:if test="${not empty ocmodel.name}"
      >&nbsp;(<c:out value="${ocmodel.name}" />)</c:if></span>
		&nbsp;
      </td>
      <td class="tableheaderbuttons">
		<div id="<c:out value='${ocmodel.id}' />_buttons">
			<c:if test="${!ocmodel.readOnly}">
				<a href="javascript:window.<c:out value='${ocmodel.id}' />Chooser.editOra()"
					><fmt:message key='application.button.edit.txt'/></a> |
				<a href="javascript:window.<c:out value='${ocmodel.id}' />Chooser.clear()"
					><fmt:message key='calendar.clear.txt'/></a>
				<c:if test="${ocmodel.showFavorites}"> |
					<a class="dropDownArrow" href="#" onclick="return window.<c:out value='${ocmodel.id}' />Chooser.showFavorites()"><fmt:message key='favorites.button.txt'/></a>
				</c:if>
			</c:if>
		</div>	<!-- tableheaderbuttons -->
      </td>
   </tr>
</table>

<div id="<c:out value='${ocmodel.id}' />_body" <c:if test="${!ocmodel.expanded}">style="display:none"</c:if>>
<div class="oraSectionbody">
	<c:if test="${not empty ocmodel.locations}">
	<table>
		<c:forEach items="${ocmodel.locations}" var="loc">
			<c:forEach items="${loc.dims}" var="dim">
				<c:forEach items="${dim.dimNodes}" var="dimNode" varStatus="status">
					<tr>
						<c:if test="${status.index == 0}">
                     <td class="oraDimensionName">
							  <span class='requiredIndicator'>
								 <c:if test="${dim.required && !ocmodel.readOnly}">*</c:if>
								 <c:if test="${not dim.required || ocmodel.readOnly}">&nbsp;</c:if>
							  </span>
                     </td>
                     <td>
                        <span class="dimName"><c:out value="${dim.name}" />:</span>
                     </td>
						</c:if>
						<c:if test="${status.index != 0}">
                     <td>&nbsp;</td><!-- Required column -->
                     <td>&nbsp;</td><!-- Name column -->
						</c:if>
						<td>&nbsp;</td><!-- Spacer column -->
						<td class="oraDimensionValue">
							<c:if test="${!ocmodel.readOnly}">
								<a href="javascript:window.<c:out value='${ocmodel.id}' />Chooser.editNode(encodeURI('<c:out value='${dimNode.handle}' />'), '<c:out value='${dim.value}' />')">
							</c:if>
							<c:if test="${not empty dimNode.path}">		
								<c:out value="${dimNode.path}" />
							</c:if>		
							<c:if test="${empty dimNode.path}">		
								<c:out value="${dimNode.name}" />
							</c:if>
							<c:if test="${!ocmodel.readOnly}">
								</a>
							</c:if>
						</td>
					</tr>
				</c:forEach>
			</c:forEach>
         <c:if test="${loc.top && empty loc.dims}">
            <c:if test="${ocmodel.everywhereAllowed}">
                <fmt:message key='ora.everywhereSelected.txt'/>
            </c:if>
            <c:if test="${!ocmodel.everywhereAllowed}">
               <fmt:message key='ora.noneSelected.txt'/>
            </c:if>
         </c:if>
		</c:forEach>
		
		<c:if test="${not empty ocmodel.standardRiskType or not empty ocmodel.standardBusinessLine}">
			<tr><td>&nbsp;</td></tr>
			<c:if test="${not empty ocmodel.standardRiskType}">
				<tr>
					<td valign="top"><span class='requiredIndicator'>&nbsp;</span></td>
					<td valign="top"><span class="dimName"><c:out value="${ocmodel.standardRiskType.name}" />:</span></td>
					<td>&nbsp;</td>
					<td><c:out value="${ocmodel.standardRiskType.path}" /></td>
				</tr>
			</c:if> 		
			<c:if test="${not empty ocmodel.standardBusinessLine}">
				<tr>
					<td valign="top"><span class='requiredIndicator'>&nbsp;</span></td>
					<td valign="top"><span class="dimName"><c:out value="${ocmodel.standardBusinessLine.name}" />:</span></td>
					<td>&nbsp;</td>
					<td><c:out value="${ocmodel.standardBusinessLine.path}" /></td>
				</tr>
			</c:if> 		
		</c:if> 		
	</table>
	</c:if>
	<c:if test="${ocmodel.top && (empty ocmodel.locations)}">
		<c:if test="${ocmodel.everywhereAllowed}">
			<fmt:message key='ora.everywhereSelected.txt'/>
		</c:if>
		<c:if test="${!ocmodel.everywhereAllowed}">
			<fmt:message key='ora.noneSelected.txt'/>
		</c:if>
	</c:if>
	<c:if test="${!ocmodel.top && empty ocmodel.locations}">
		<fmt:message key='ora.noneSelected.txt'/>
	</c:if>
</div>	<!-- sectionbody -->
	
<jsp:include page="/components/ora/ModeSelector.jsp" />
	
</div>	<!-- _body -->
</div>	<!-- section -->