<%@page import="java.util.*"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@page import="com.sas.solutions.cpb.web.util.RequestUtil"%>
<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.oprisk.framework.server.util.ParsingUtils"%>
<%@page import="com.sas.oprisk.monitor.web.costComponent.CostComponentAction"%>
<%@page import="com.sas.oprisk.server.web.cpb.runtime.MonitorUIContext"%>
<%@ include file="/tiles/taglibs.jsp" %>
<%@page import="com.sas.solutions.cpb.screendefs.*" %>
<%@page import="com.sas.oprisk.server.cpb.uiDefType.*"%>
<mon:include js="/dwr/engine.js" />
<mon:include js="/dwr/util.js" />
<mon:include js="/dwr/interface/CommonService.js" />

<%
   final ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);

   final UIContext uiContext = RequestUtil.getUIContext(request);
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);
   final Field field = componentInfo.getField();
   
   CostComponentContainer costComponentContainer=null;
   String attachedToTpHandle=null;
   Object busObj = uiContext.getValue(MonitorUIContext.DefaultField.BUSINESS_OBJECT.getName());
   
   if (busObj instanceof CostComponentContainer) {
      costComponentContainer = (CostComponentContainer)busObj;
      attachedToTpHandle=costComponentContainer.getTaggedPointerHandle().toString();
   }  
%>
      
<script type="text/javascript">

function popupCostComponent(method,attachedToTpHandle) {
   var winName = "costCompPopup";
   if (attachedToTpHandle == null)
   {
      attachedToTpHandle = "<%= attachedToTpHandle %>";
   }
   openModal("<%= request.getContextPath() %>/CostComponentAction.do?method=" 
		   + method + "&attachedToTpHandle=" + encodeURI(attachedToTpHandle) + "&"   
		   + "<%=  CostComponentAction.PARAM_UI_DEF_TYPE 
		   + "=" +  uiContext.getUIContextId()%>"   
		   +   "&" + "<%=  CostComponentUIDefinitionType.FIELD_COSTS 
		   + "=" +  field.getName()%>" ,  
		   winName);
      
   // then submit the form into it (updates the context with any new values)
  // var f = document.forms.<c:out value="${componentInfo.formName}" />;
   //f.target = winName;  // target is the modal window
   //doRecommendation("forward&bc=false&path=" + escape("/CostComponentAction.do?method=" + method));
   //f.target = ""; // reset the target
}



function addCostComponent(attachedToTpHandle) {
   popupCostComponent("create",attachedToTpHandle);
}

function viewCostComponent(handle) {
   popupCostComponent("select&handle=" + handle + "&readOnly=<%= componentInfo.isReadOnly() %>");
}

function deleteCostComponent(handle, desc) {
   var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
      "CostComponent.deleteCostComponent.confirm.message.fmt.txt")) %>");
   msg = formatMessage(msg, unescape(desc));
   if (confirm(msg)) {
      CommonService.deleteCostComponent(
            handle,
            "<c:out value='${componentInfo.field.name}' />",
            "<c:out value='${componentInfo.component.name}' />",
            getCostCompParams(),
            function(pageMod) {
              PageModification.handle(pageMod);
            }
      );
   }
}

//refresh table content
function refreshCostComponents() {
   CommonService.refreshCostComponents(
      "<c:out value='${componentInfo.field.name}' />",
      "<c:out value='${componentInfo.component.name}' />",
      getCostCompParams(),
      function(pageMod) {
        closeModal("costCompPopup");
        PageModification.handle(pageMod);
      }
   );
}

function getCostCompParams() {
   var f = document.forms.<c:out value="${componentInfo.formName}" />;
   var params = getParamsForTable(f, "<c:out value='${componentInfo.component.tableEntryId}' />", "<c:out value='${componentInfo.field.name}' />");
   
//   params.rrHandle = f.rrHandle.value; // needed to retrieve the risk recommendation
   //params.riHandle = f.riHandle.value; // needed to retrieve the risk instance
   //params.qnrHandle = f.qnrHandle.value; // needed to retrieve the sheet

   return params;
}

TableComponent.prototype.getQueryEditorURL = function()
{
   var busObjForNamedList=  this.tableParameters.getBusinessObjectTypeForNamedLists();
   return "QueryEditor.do?entryId=" + this.entryName + "&busObjForNamedList=" +busObjForNamedList;
}
</script>
 
<a name="cost_comp"></a>

<div id="<c:out value='${componentInfo.component.htmlElementId}' />" >
<jsp:include page = "CostTableContent.jsp" />
</div>  

<script type="text/javascript">
   // override the submit function to use ajax
   getTableComponent("<c:out value='${componentInfo.component.tableEntryId}' />", "<c:out value='${componentInfo.field.name}' />").submit = refreshCostComponents;
</script>
