<%@page import="com.sas.web.keys.CommonKeys"%>
<%@page import="org.springframework.security.core.userdetails.UserDetails"%>
<%@page import="org.springframework.security.core.context.SecurityContext"%>
<%@page import="java.security.Principal"%>
<%@page import="com.sas.oprisk.framework.server.persistence.PersistenceSession"%>
<%@page import="com.sas.oprisk.server.User"%>
<%@page import="com.sas.oprisk.server.util.DelegationUtils"%>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.*" %>
<%@ page import="com.sas.fsd.shared.util.StringUtil" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>
<%@ page import="com.sas.oprisk.monitor.web.*" %>
<%@ page import="com.sas.oprisk.monitor.web.layout.*" %>
<%@ page import="com.sas.oprisk.monitor.web.layout.template.*" %>
<%@ page import="com.sas.oprisk.monitor.web.utils.*" %>
<%@ page import="com.sas.oprisk.framework.server.persistence.PersistenceUser" %>
<%@ page import="com.sas.oprisk.monitor.web.actions.ActionConstants" %>
<%@ page import="com.sas.oprisk.server.services.ServiceLocator" %>
<%@ page import="com.sas.svcs.config.client.UrlGeneratorInterface" %>
<%@ page import="com.sas.svcs.directives.client.*" %>
<%@ taglib uri="http://www.sas.com/taglib/sas" prefix="sas"
%>
<%
   PageLayout pageLayout = PageLayout.getPageLayout(request);
   PageTemplate pageTemplate = pageLayout.getPageTemplate();
   
   MonitorSession monitorSession = MonitorSession.getMonitorSession(request, false);
   PersistenceUser user = (monitorSession == null) ? null : monitorSession.getUser();
   LayoutDirection layoutDirection = LayoutDirection.getLayoutDirection(request);
   ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   
   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   String vaHubUrl=request.getParameter(CommonKeys.PFS_REQUEST_BACKURL_LIST);
   if(vaHubUrl==null)vaHubUrl=(String)session.getAttribute("GRC_"+CommonKeys.PFS_REQUEST_BACKURL_LIST);
   String vaHubLabel=request.getParameter(CommonKeys.PFS_REQUEST_BACKLABEL_LIST);
   if(vaHubLabel==null)vaHubLabel=(String)session.getAttribute("GRC_"+CommonKeys.PFS_REQUEST_BACKLABEL_LIST);
   
   boolean comingFromVA = false;
   String safeVaUrl = null;
   if(vaHubUrl!=null && vaHubLabel!=null)
   {
      //We could validate the vaHubUrl, but just use the directive version instead
      UrlGeneratorInterface urlGenerator = ServiceLocator.getUrlGenerator();
      DirectiveServiceInterface directiveSvc = ServiceLocator.getDirectiveService();
      List<Directive> dList = directiveSvc.find("VisualAnalyticsHubLogon");
      
      if (dList != null && !dList.isEmpty())
      {
         Directive d = dList.get(0);
         safeVaUrl = urlGenerator.generateExternalUrl(d.getAppName(), d.getUri(), (String)null);
      }
      
      if (safeVaUrl != null)
      {
         session.setAttribute("GRC_"+CommonKeys.PFS_REQUEST_BACKURL_LIST, safeVaUrl);
         session.setAttribute("GRC_"+CommonKeys.PFS_REQUEST_BACKLABEL_LIST,vaHubLabel);  
         comingFromVA = true;         
      }
   }
%>
<div id="banner" class="banner_container" style='<%=layoutDirection.getLeft()%>: 0; position: relative;'>
  
  <%
  // displayed for the log off banner.  remove when not needed
  if (pageTemplate.getShowGlobalBannerMenuBar(pageLayout))
  {
     %>
   <div class="banner_utilitybar_overlay">&nbsp;</div>
   <%
  }
  %>
  <table class="banner_utilitybar" border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr><%-- insert a TD with a one-pixel navigation link --%>
         <td class="bbannerSkipNav SimpleMenuBarItem_Banner_GlobalMenu_Look"><a href="#mainContentArea"><img src="<%=request.getContextPath()%>/images/spacer.gif"
             width="1" height="1" border="0"
             class="skipnav"
             alt="<%=com.sas.servlet.tbeans.html.RB.getStringResource(
                        "Banner.alt.skip.txt",
                        request.getLocale())%>" /></a>
                        
<%
if(comingFromVA){ %>
   <img src="images/BannerBackArrowYellow<%=(layoutDirection.isRightToLeft()?"RTL":"") %>.gif" alt="Back">
   <a id="vabreadcrumb" target="_top" href="<%=safeVaUrl%>" onmouseover="window.status='Back';return true" class=""><%=StringUtil.escapeHTML(vaHubLabel)%></a>
<%}%>                            
         </td>
<%
   if ((monitorSession != null) && monitorSession.hasBackToUrl(session)) {
%>
         <td class="banner_utilitybar_navigation" width="40%" align="<%=layoutDirection.getLeft()%>">
               &nbsp;  <a id="backToUrl" href="<%= monitorSession.getBackToUrl(session) %>" target="_top" title="<%= monitorSession.getBackToDesc(session) %>" tabindex=2><sas:ThemedImage image="Banner_backArrow" />
               <%= monitorSession.getBackToTitle(session) %></a>
         </td>
<%
   }
   if (pageTemplate.getShowGlobalBannerMenuBar(pageLayout))
   {
      String userId = user.getUserId();
      String displayName = user.getDisplayNm(request.getLocale());
      if(DelegationUtils.isImpersonated(psession))
      {
         SecurityContext myself=DelegationUtils.getMyself(psession);
         userId+=" ("+myself.getAuthentication().getName()+")";
         Object principal=myself.getAuthentication().getPrincipal();
         String name=(principal instanceof Principal)?((Principal)principal).getName():(principal instanceof UserDetails)?((UserDetails)principal).getUsername():principal.toString();
         try
         {
            User u=User.object.fetchByUserId(name, psession);
            name=u.getDisplayNm(request.getLocale());
         }
         catch(NoSuchElementException e){/*throw away, use the name as-is*/}
         displayName+=" ("+name+")";
      }
%>                   
         <td align="<%=layoutDirection.getRight()%>">
            <div id="globlMenuBar" class="SimpleMenuBar SimpleMenuBar_Banner_GlobalMenu_Look">
            <table border="0" cellpadding="0" cellspacing="0">
               <tr>
                  <td class="SimpleMenuBarItem SimpleMenuBarItem_Banner_GlobalMenu_Look">
                     <a href="<%= RequestUtilities.getLogoffURL(request) %>"
                        title="<%= pageLayout.getString("logout.tooltip.userID.txt") %>:&nbsp;<%= StringUtil.escapeHTML(userId) %>">
                        <%= bundle.getString("logout.title")%>&nbsp;&nbsp;<%= StringUtil.escapeHTML(displayName) %>
                     </a>
                  </td>
                  <td>
                     <span class="SimpleMenuBarSeparator SimpleMenuBarSeparator_Banner_GlobalMenu_Look">|</span>
                     &nbsp;
                  </td>
                  <td class="SimpleMenuBarItem SimpleMenuBarItem_Banner_GlobalMenu_Look">
                     <jsp:include page="/layout/BannerPreferences.jsp" />
                  </td>
                  <td>
                     <span class="SimpleMenuBarSeparator SimpleMenuBarSeparator_Banner_GlobalMenu_Look">|</span>
                     &nbsp;
                  </td>
                  <td class="SimpleMenuBarItem SimpleMenuBarItem_Banner_GlobalMenu_Look">
                     <jsp:include page="/layout/BannerHelp.jsp" />
                     &nbsp;
                  </td>
               </tr>
            </table>
            </div>
         </td>
<%
   }
%>
      </tr>
   </table>
   <jsp:include page="/layout/BannerContent.jsp" />
<%
   if (user != null)
   {
      %><div class="secondaryMenuRow secondaryMenuTable" id="mainNavigationMenuBar"><%
      pageTemplate.writeBannerNavigationMenu(pageLayout, pageContext);
      %></div><%
   }
%>
</div>