<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.component.assessment.PopulatedRiskTableComponent"%>
<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.component.assessment.PopulatedControlTableComponent"%>
<%@page import="com.sas.oprisk.framework.server.util.*" %>
<%@page import="com.sas.oprisk.server.ApplicationProperties"%>
<%@page import="java.util.*"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@page import="com.sas.solutions.cpb.web.util.RequestUtil"%>
<%@page import="com.sas.oprisk.server.logical.DimensionalAreaHandle"%>
<%@page import="com.sas.oprisk.server.cpb.uiDefType.AssessmentUIDefinitionType"%>
<%@page import="com.sas.solutions.cpb.runtime.UIContext"%>
<%@page import="com.sas.solutions.cpb.web.tag.field.ComponentFieldRenderer"%>
<%@page import="com.sas.oprisk.monitor.web.cpb.runtime.component.assessment.PopAsblTableComponent"%>
<%@page import="com.sas.oprisk.server.web.cpb.runtime.MonitorUIContext"%>
<%@page import="com.sas.oprisk.monitor.web.csa.assessment.*"%>
<%@page import="com.sas.oprisk.server.logical.DimensionalArea"%>
<%@page import="com.sas.solutions.cpb.web.util.CPBWebConstants"%>
<%@page import="com.sas.oprisk.monitor.web.table.CustomTableComponentAction"%>

<%@ include file="/tiles/taglibs.jsp" %>

<%@page import="com.sas.oprisk.server.cpb.uiDefType.BaseAssessmentUIDefinitionType"%><%
   final boolean isPreview = Boolean.TRUE.equals(request.getAttribute(CPBWebConstants.ATTR_PREVIEW));
   final ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);

   final UIContext uiContext = RequestUtil.getUIContext(request);
   final ComponentFieldRenderer.ComponentInfo componentInfo =
      ComponentFieldRenderer.getComponentInfo(request);
   final String fieldName = componentInfo.getField().getName();
   final AssessmentModel model = isPreview ? null : AssessmentAction.getModel(request, psession);
   
   final Assessment assessment = (Assessment)uiContext.getValue(
      MonitorUIContext.DefaultField.BUSINESS_OBJECT.getName());
   final DimensionalArea location = assessment == null ? DimensionalArea.object.getTop(psession)
      : assessment.getLocation(psession);
   
   // is this for assessments, or assessment templates?
   final boolean fromAssessments = assessment == null ? true : !assessment.getTemplateFlg().booleanValue(); 
   
   final AssessableTypeCd asblTypeCd = ((PopAsblTableComponent)componentInfo.getComponent()).getAssessableTypeCd();
   final String asblType = asblTypeCd.getValue();
   final String statusFilter=(String)request.getAttribute(PopAsblTableComponent.PARAM_STATUS_FILTER);
   
   final boolean isOwner = Boolean.TRUE.equals(request.getAttribute("isOwner"));
  
   String asblTableEntryName = null;
   String objTypeKey = null;
   String selectAsblAction = null;
   String asblTitleKey = null;
   String selectAsblKey = null;
   String createAsblKey = null;
   boolean canAddAsbls = false;
   boolean canCreateAsbls = false;

   // === begin differences in assessable types
   if (AssessableTypeCd.control.equals(asblTypeCd)) {
      asblTableEntryName = PopAsblTableAction.TABLE_CONTROLS;
      objTypeKey = ControlInstance.object.getBusinessObjectInfo().getDisplayNameKey();
      selectAsblAction = "PopulatedControlChooser";
      asblTitleKey = "AssessmentWizard.scoping.controlTable.title.txt";
      selectAsblKey = "AssessmentWizard.scoping.button.addControl.txt";
      createAsblKey = "AssessmentWizard.scoping.button.createControl.txt";
      
      // controls don't have to be created at the same location as the sheet
      canCreateAsbls = ControlInstance.object.canSomewhere(Do.CREATE, psession);
      canAddAsbls = ControlInstance.object.canSomewhere(Do.READ, psession); 
   } else if (AssessableTypeCd.potentialImpact.equals(asblTypeCd)) {
      asblTableEntryName = PopAsblTableAction.TABLE_IMPACTS;
      objTypeKey = PotentialImpact.object.getBusinessObjectInfo().getDisplayNameKey();
      selectAsblAction = "PopulatedImpactChooser";
      asblTitleKey = "AssessmentWizard.scoping.impactTable.title.txt";
      selectAsblKey = "AssessmentWizard.scoping.button.addImpact.txt";
      createAsblKey = "AssessmentWizard.scoping.button.createImpact.txt";
      
      // impacts don't have to be created at the same location as the sheet
      canCreateAsbls = PotentialImpact.object.canSomewhere(Do.CREATE, psession);
      canAddAsbls = PotentialImpact.object.canSomewhere(Do.READ, psession); 
   } else { // assume risks, for now
      asblTableEntryName = PopAsblTableAction.TABLE_RISKS;
      objTypeKey = RiskInstance.object.getBusinessObjectInfo().getDisplayNameKey();
      selectAsblAction = "PopulatedRiskChooser";
      asblTitleKey = "AssessmentWizard.scoping.riskTable.title.txt";
      selectAsblKey = "AssessmentWizard.scoping.button.addRisk.txt";
      createAsblKey = "AssessmentWizard.scoping.button.createRisk.txt";
      canCreateAsbls = RiskInstance.object.can(Do.CREATE, location, psession);
      canAddAsbls = canCreateAsbls; // adding a risk will create a risk, if the areas don't match 
   }
   // === end differences in assessable types
   
   final String objType = ParsingUtils.escape(bundle.getString(objTypeKey));
   final String assessorHandles = BaseAssessmentUIDefinitionType.getAssessorHandles(uiContext);
   final String sheetHandles = BaseAssessmentUIDefinitionType.getAnswerSheetHandles(uiContext);
   final String handleParam = fromAssessments ? "asmtHandle" : "asmtTemplateHandle";
%>

<script type="text/javascript">

<c:if test="${not PATC.jsRendered}">
function getAssessorHandles() {
   var f = document.forms.<c:out value="${componentInfo.formName}" />;
   return f.<%=AssessorTableAction.ATTR_ASSESSOR_HANDLES%> === undefined
      ? '<%=assessorHandles%>'
      : f.<%=AssessorTableAction.ATTR_ASSESSOR_HANDLES%>.value;
}

function getSheetHandles() {
   var f = document.forms.<c:out value="${componentInfo.formName}" />;
   return f.<%=AssessorTableAction.ATTR_SHEET_HANDLES%> === undefined
      ? '<%=sheetHandles%>'
      : f.<%=AssessorTableAction.ATTR_SHEET_HANDLES%>.value;
}

function getAssessableParameters(asblTableEntryName, fieldName) {
   var f = document.forms.<c:out value="${componentInfo.formName}" />;
   var params = getParamsForTable(f, asblTableEntryName, fieldName);
   params.assessmentHandle = "<c:out value='${uiContext.handle}' />"; // needed to retrieve the assessment
   return params;
}
<c:set var="PATC.jsRendered" value="true" />
</c:if>

function create<%= asblType %>Assessable() {
   doAssessment("createAssessable"
      + "&asblType=<%= asblType %>"
      + "&assessors=" + encodeURI(getAssessorHandles())
      + "&fromAssessments=<%= fromAssessments %>"
      + "&allowBlankExpertSelection=<%= !fromAssessments %>"
      + "&<%= handleParam %>=" + encodeURI("<c:out value='${uiContext.handle}' />")
      + "&<%= AssessmentUtils.CPB_FIELD_NAME %>=<%= fieldName %>"
      );
}

function edit<%= asblType %>Assessable(handleParam, handle, aasHandle, pointInTime) {
   doAssessment("editAssessable"
      + "&asblType=<%= asblType %>"
      + "&" + handleParam + "=" + encodeURI(handle)
      + "&assessors=" + encodeURI(getAssessorHandles())
      + "&answerSheetHandles=" + encodeURI(getSheetHandles())
      + "&aasHandle=" + encodeURI(aasHandle)
      + "&qnrHandle=" + encodeURI(aasHandle)
      + "&fromAssessments=<%= fromAssessments %>"
      + "&<%= handleParam %>=" + encodeURI("<c:out value='${uiContext.handle}' />")
      + "&<%= AssessmentUtils.CPB_FIELD_NAME %>=<%= fieldName %>"
      + (pointInTime ? ("&pointInTime=" + pointInTime) : ""));
}

<% if (AssessableTypeCd.risk.value.equals(asblType)) { %>
function editRisk(handle, aasHandle, pointInTime) {
   edit<%= asblType %>Assessable("riHandle", handle, aasHandle, pointInTime);
}
<% } else if (AssessableTypeCd.control.value.equals(asblType)) { %>
function editControl(handle, aasHandle, pointInTime) {
   edit<%= asblType %>Assessable("ciHandle", handle, aasHandle, pointInTime);
}
<% } else if (AssessableTypeCd.potentialImpact.value.equals(asblType)) { %>
function editImpact(handle, aasHandle, pointInTime) {
   edit<%= asblType %>Assessable("potentialImpactHandle", handle, aasHandle, pointInTime);
}
<% } %>

function select<%= asblType %>Assessable() {
   openModal(
      "<%= request.getContextPath() %>" 
         + "/<%= selectAsblAction %>.do"
         + "?<%= handleParam %>=" + encodeURI("<c:out value='${uiContext.handle}' />")
         + "&qAction=<%= selectAsblAction %>"
         + "&assessableTypeCd=<%= asblType %>"
         <%if(statusFilter!=null){%>
         + "&statusFilter=<%=statusFilter%>"
         <%}%>            
         + "&location=" + encodeURI(getAssessmentArea())
         + "&fromAssessments=<%= fromAssessments %>"
         + "&assessors=" + encodeURI(getAssessorHandles()),
      "selectAsblPopup");
}

function add<%= asblType %>Assessables(selectionArray, assessor, createCopy) {
   var params = getAssessableParameters("<%= asblTableEntryName %>", "<%= fieldName %>");
   if (createCopy) {
      params.createCopy = createCopy;
   }

   RCSAService.addAssessables(
         "<c:out value='${componentInfo.field.name}' />",
         "<c:out value='${componentInfo.component.name}' />",
         "" + selectionArray, assessor,
         params,
         function(pageMod) {
           PageModification.handle(pageMod);
           <c:if test="${componentInfo.field.hasOnChangeActions}">
           cpb.fieldValueChanged("<c:out value='${componentInfo.field.name}' />"); // signal a change occurred
           </c:if>
         }
      );
}

function remove<%= asblType %>Assessable(asblHandle, answerSheet, id) {
   var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
      "AssessmentWizard.removeAssessable.confirm.message.fmt.txt")) %>");
   msg = formatMessage(msg, unescape("<%= objType %>"), unescape(id));
   if (confirm(msg)) {
      RCSAService.removeAssessable(
            "<c:out value='${componentInfo.field.name}' />",
            "<c:out value='${componentInfo.component.name}' />",
            asblHandle, answerSheet,
            getAssessableParameters("<%= asblTableEntryName %>", "<%= fieldName %>"),
            function(pageMod) {
              PageModification.handle(pageMod);
              <c:if test="${componentInfo.field.hasOnChangeActions}">
              cpb.fieldValueChanged("<c:out value='${componentInfo.field.name}' />"); // signal a change occurred
              </c:if>
            }
         );
   }
}

function selectNew<%= asblType %>Assessor(aasHandle, asblHandle, allowClear) {
   openModal("<%= request.getContextPath() %>/ExpertChooserQuery.do"
         + "?<%= CPBWebConstants.PARAM_UI_CONTEXT_ID %>=<%= uiContext.getUIContextId() %>" 
         + "&aasHandle=" + encodeURI(aasHandle)
         + "&asblHandle=" + encodeURI(asblHandle)
         + "&assessableTypeCd=<%= asblType %>"
         + "&allowClear=" + allowClear,
      'user_popup');
}

function move<%= asblType %>AsblsBetweenAnswerSheets(destAssessorHandle, srcAnswerSheetHandle, asblHandle) {
   RCSAService.reassignAssessable(
         "<c:out value='${componentInfo.field.name}' />",
         "<c:out value='${componentInfo.component.name}' />",
         asblHandle, srcAnswerSheetHandle, destAssessorHandle,
         getAssessableParameters("<%= asblTableEntryName %>", "<%= fieldName %>"),
         function(pageMod) {
           PageModification.handle(pageMod);
           <c:if test="${componentInfo.field.hasOnChangeActions}">
           cpb.fieldValueChanged("<c:out value='${componentInfo.field.name}' />"); // signal a change occurred
           </c:if>
         }
      );
}

//refresh table content
function refresh<%= asblType %>Assessables() {
   RCSAService.refreshAssessables(
      "<c:out value='${componentInfo.field.name}' />",
      "<c:out value='${componentInfo.component.name}' />",
      getAssessableParameters("<%= asblTableEntryName %>", "<%= fieldName %>"),
      function(pageMod) {
        PageModification.handle(pageMod);
      }
   );
}

</script>

    <!-- Populated Assessables -->
    
<a name="<%= asblType %>asbls"></a>

<div id="pop_<%= asblTypeCd %>_div" >
<jsp:include page = "PopAsblTableContent.jsp" />
</div>  

<script type="text/javascript">
   // override the submit function to use ajax
   getTableComponent("<%= asblTableEntryName %>", "<%= fieldName %>").submit = refresh<%= asblTypeCd %>Assessables;
</script>
