<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%    
	final Locale locale = request.getLocale();
	final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
	final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
	final boolean isFormBased = ConfigDataProperties.isRcsaFormBasedAssessmentsEnabled();
	request.setAttribute("formBased",Boolean.valueOf(isFormBased));
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      <%-- not needed for now
      var statusMap = new Array();
      --%>
      
      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.queryForm.submit();
         return false;
      }
      
      function createControlInstance() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ControlInstance.do"
               + "?method=create";
         f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function deleteControlInstance(handle, name) {
         var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
            "ControlInstance.delete.confirm.message.fmt.txt")) %>");
         msg = formatMessage(msg, unescape(name));
         if (confirm(msg)) {
            goControlInstance("delete", handle, false);
         }
      }
      
      function goControlInstance(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/ControlInstance.do"
               + "?method=" + method
               + "&handle=" + encodeURI(handle);
         document.forms.queryForm.submit();
      }
      
      function showContextMenu(handle, name) {
         var menu = new TableMenu();
         <c:if test="${canDelete}">
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<fmt:message key='application.delete.image'/>", "<fmt:message key='application.button.delete.txt'/>", "javascript:deleteControlInstance('" + handle + "', '" + name + "')"));
         </c:if>
         menu.render();
         return false;
      }
      
      TableComponent.prototype.getQueryEditorURL = function()
      {
         var busObjForNamedList=  this.tableParameters.getBusinessObjectTypeForNamedLists();
         return "QueryEditor.do?entryId=" + this.entryName + "&busObjForNamedList=controlInstance"
      }
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ControlInstanceQuery">      
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createControlInstanceLink" onclick="createControlInstance(); return false;"><fmt:message key='controlInstance.create.txt'/></a>
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="controlInstanceEx" disableTableActions="true" >
            <mon:title><fmt:message key="Control.title.txt"/></mon:title>
         <%
         
               final ControlInstanceEx controlInstanceEx = (ControlInstanceEx)pageContext.findAttribute("controlInstanceEx");
              
             if (controlInstanceEx != null) {
               final String ctrlInstNm = ParsingUtils.escape(controlInstanceEx.getControlInstNm());
               final Boolean isPartial = new Boolean(controlInstanceEx.isPartial(psession));
               pageContext.setAttribute("isPartial", isPartial);
         %>
            <c:if test="${canDelete or canCreate}">
            <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
         
               &nbsp;<a id="contextMenu" href="#" onclick="return showContextMenu('<c:out value='${controlInstanceEx.handleString}'/>', '<%= ctrlInstNm %>')"
               ><img border="0"
                   src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                  alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  title="<fmt:message key='application.rowActions.tooltip.txt'/>"
               /></a>&nbsp;
            </mon:fixedColumn>
            </c:if>
         
         <%
            }
         %>
          
         </mon:tableComponent>
         
         <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
