<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="java.util.*" %>

<%
Map colFormatters = (Map)request.getAttribute("colFormatters");
Boolean canCreate = (Boolean)request.getAttribute("canCreate");
Locale locale = request.getLocale();
ResourceBundle  bundle = ApplicationProperties.getBundle(locale);


%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function createActionPlan() {
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ActionPlan.do"
               + "?method=create";
         f.LOCATION.value = f.TCArea.value;
         f.submit();
      }
      
      function createNewFrom(handle) {
         beginWait();
         var f = document.forms.queryForm;
         f.action =
            "<%= request.getContextPath() %>/ActionPlan.do"
               + "?method=createNewFrom&handle=" + encodeURI(handle);
         f.submit();
      }
      
      function showContextMenu(handle) {
         var menu = new TableMenu();
         menu.addMenuItem(
               new MenuItem(MenuItem.prototype.action,
                   "<%= request.getContextPath() %>/" + "<fmt:message key='application.createNew.image'/>", 
                   "<fmt:message key='application.createNewFrom.tooltip.txt'/>", 
                   "javascript:createNewFrom('" + handle + "')",
                   true));
       
         menu.render();
         return false;
      }
      
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/ActionPlanQuery">      
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <a class="toolBarAction" href="#" id="createActionPlanLink" onclick="createActionPlan(); return false;"><fmt:message key='iap.actionPlan.actionPlanCreate.button.txt'/></a>
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent columnFormatters="<%=colFormatters%>" id="actionPlan" disableTableActions="true" >
            <%
               if (canCreate) { 
                %>
                  <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                     &nbsp;
                     <a href="#" onclick="return showContextMenu('<c:out value='${actionPlan.handleString}'/>')">
                     <img border="0"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                        alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                        title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     />
                     </a>
                     &nbsp;
                  </mon:fixedColumn>
               <%    }  %>
            
            </mon:tableComponent>
            
            <input type="hidden" name="LOCATION" />
                        
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>
