<%@ page import="com.sas.oprisk.server.iap.IapConstants" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>
<%@ page import="com.sas.oprisk.monitor.web.iap.actionplan.*" %>
<%@ include file="/tiles/taglibs.jsp" %>

<%
   final java.util.Locale locale = request.getLocale();
   final java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   String handle = (String) request.getAttribute("actionPlanHandle");
   boolean readOnly = Boolean.TRUE.equals(request.getAttribute("readOnly"));
   String methodName = "view";
   String exportMethodName = "";
   String exportHandle = "";
   exportMethodName = methodName;
   methodName = methodName + "&uc=true"; //get the values from cache for actionplan create mode
   exportHandle = handle == null ? "":"&handle=" + handle;
   
   String usersToNotifyExportUrl = request.getContextPath() + "/ActionPlan.do?method=" + exportMethodName + exportHandle
      + "&entryId=usersToNotify";
   
%>   

<script type="text/javascript">

function addUser() {
   openModal("<%= request.getContextPath() %>/UserQueryForActionPlan.do"
      + "?apHandle=" + encodeURI(document.forms.newActionPlanForm.handle.value)
      + "&area=" + encodeURI(document.forms.newActionPlanForm.LOCATION.value),
      "subs_popup", "width=750,height=500,scrollbars,resizable");
}

function deleteUser(userHandle) {
   document.forms.newActionPlanForm.action = "<%= request.getContextPath()%>/ActionPlan.do"
      + "?method=forward&forward=UnsubscribeUser"
      + "&subjectHandle=" + encodeURI(document.forms.newActionPlanForm.handle.value) 
      + "&subjectType=ActionPlan"
      + "&userHandle=" + encodeURI(userHandle);
   document.forms.newActionPlanForm.submit();
}

function popupCloser_refresh(){
      doActionPlan("refresh");
}

</script>

 

<!-- Notify List table -->
<div id="ActionPlan_users">
<p />
<mon:tableComponent id="user" entryName="usersToNotify" exportXlsUrl="<%= usersToNotifyExportUrl %>"  wizCursor="refresh" >
   <mon:title><fmt:message key="iap.actionPlan.actionPlanView.notifyList.section.txt"/></mon:title>
   
   <c:if test="${!componentInfo.readOnly}">
   <mon:action id="addUsersToNotifyLink" href="javascript:addUser()">
         <fmt:message key='application.add.txt'/>
   </mon:action>
   <mon:fixedColumn width="1%" before="false" title='<%= bundle.getString("application.remove.txt") %>' >
         <a href="javascript:deleteUser('<c:out value="${user.handleString}" />')">
            <img border="0" src="<fmt:message key='application.remove.image' />"  
            alt="<fmt:message key='application.remove.txt'/>" 
            title="<fmt:message key='application.remove.txt'/>"/>
         </a>
   </mon:fixedColumn>
   </c:if>
</mon:tableComponent>
</div>
