<%-- MENU: Financial Data > Insurance Policies > Insurance Policies[any] --%>
<%@ include file="/tiles/taglibs.jsp" %>
<%@ page import="com.sas.oprisk.monitor.web.insurancepolicy.actions.InsurancePolicyModel" %>
<%@ page import="com.sas.oprisk.monitor.web.tags.smarttags.SmartLabelTag" %>
<%
   InsurancePolicyModel model = (InsurancePolicyModel)request.getAttribute("model");
   String formName = (String) request.getAttribute("formName");
   String context  = request.getContextPath();
%>

<mon:Page template="details">

<mon:Head>

<script type="text/javascript"
   src='<%= request.getContextPath()%>/dwr/interface/MonitorServer.js'></script>
<script type="text/javascript"
   src='<%= request.getContextPath()%>/dwr/engine.js'></script>
<script type="text/javascript"
   src='<%= request.getContextPath()%>/dwr/util.js'></script>

<%-- ****************************************************************** --%>
<%-- InsurancePolicyEditor.jsp --%>
<%-- ****************************************************************** --%>

<script type="text/javascript">

function performAction( actionName, method ) {
	document.forms.<%=formName%>.action = 
		"<%= context + '/' %>"
        + actionName + ".do?handle=" + encodeURI(document.forms.<%=formName%>.handle.value)
        + (method ? "&method=" + method : "");
    document.forms.<%=formName%>.submit();
}

function forward(path) {
   performAction('InsurancePolicy', 'forward&path=' + escape(path));
}


</script>

</mon:Head>

<mon:Body>

<mon:form action="/InsurancePolicy">

<mon:ToolBar>

   <c:if test="<%= !model.isReadOnly() %>" >
      <mon:Button type="button"
         onclick="performAction('InsurancePolicy', 'save')">
         <fmt:message key='saveButton.txt' />
      </mon:Button>

      <mon:Button type="button" 
         onclick="breadcrumb('${formName}')">
         <fmt:message key='cancelButton.txt' />
      </mon:Button>
   </c:if>
   <c:if test="<%= model.isReadOnly() %>" >
      <mon:Button type="button"
         onclick="breadcrumb('${formName}')">
         <fmt:message key='returnButton.txt' />
      </mon:Button>
   </c:if>
   
</mon:ToolBar>

<mon:Content>
   <input type="hidden" name="handle" value="<c:out value="${uiContext.handle}"/>"/>
   <cpb:screen screenID="${insurancePolicyForm.screenId}" readOnly="<%= model.isReadOnly() %>"/>         
</mon:Content>  

</mon:form>

</mon:Body>

</mon:Page>